'use strict';

exports.__esModule = true;
exports.withMiddlewares = exports.recursive = undefined;

var _compose = require('./compose');

var _compose2 = _interopRequireDefault(_compose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var METADATA = Symbol('recursive-func@METADATA');

var applyMiddlewares = function applyMiddlewares(middlewares, func) {
  return middlewares.length !== 0 ? (0, _compose2.default)(middlewares)(func) : func;
};

var unwrapMetadata = function unwrapMetadata(func) {
  return func[METADATA];
};

var recursive = exports.recursive = function recursive(func) {
  var _Object$assign;

  var middlewares = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var wrapper = applyMiddlewares(middlewares, func(function () {
    return wrapper.apply(undefined, arguments);
  }));

  return Object.assign(wrapper, (_Object$assign = {}, _Object$assign[METADATA] = {
    func: func,
    middlewares: middlewares
  }, _Object$assign));
};

var withMiddlewares = exports.withMiddlewares = function withMiddlewares(middlewares, wrapper) {
  var metadata = unwrapMetadata(wrapper);

  return recursive(metadata.func, [].concat(metadata.middlewares, middlewares));
};